#define USE_GLU
#define POLAR_VIEW
// SolidosPlatonicos.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>
#include <GL\glut.h>

/* menu options */
#define MENU_EXIT			1
#ifdef USE_GLU
#define MENU_GLU_WIRECYLINDER	2
#define MENU_GLU_SOLIDCYLINDER	3
#define MENU_GLU_WIREDISK			4
#define MENU_GLU_SOLIDDISK			5
#define MENU_GLU_WIREPARTIALDISK	6
#define MENU_GLU_SOLIDPARTIALDISK	7
#define MENU_GLU_WIRESPHERE			8
#define MENU_GLU_SOLIDSPHERE		9
#define MENU_GLU_CYLINDER2WIRE		10
#define MENU_GLU_CYLINDER2SOLID		11
#endif
#define MENU_GLUT_WIRESPHERE	20
#define MENU_GLUT_SOLIDSPHERE	21
#define MENU_GLUT_WIRECONE		22
#define MENU_GLUT_SOLIDCONE		23
#define MENU_GLUT_WIRECUBE		24
#define MENU_GLUT_SOLIDCUBE		25
#define MENU_GLUT_WIRETORUS		26
#define MENU_GLUT_SOLIDTORUS	27
#define MENU_GLUT_WIREDODECAHEDRON	28
#define MENU_GLUT_SOLIDDODECAHEDRON	29
#define MENU_GLUT_WIREOCTAHEDRON	30
#define MENU_GLUT_SOLIDOCTAHEDRON	31
#define MENU_GLUT_WIRETETRAHEDRON	32
#define MENU_GLUT_SOLIDTETRAHEDRON	33
#define MENU_GLUT_WIREICOSAHEDRON	34
#define MENU_GLUT_SOLIDICOSAHEDRON	35
#define MENU_GLUT_WIRETEAPOT		36
#define MENU_GLUT_SOLIDTEAPOT		37
#define MENU_RESET_CAMERA			38
#define MENU_RESET_CAMERAORG		39



int obj = MENU_GLUT_WIRESPHERE;
int slices = 10;
int stacks = 10;

/* camara */
#ifdef POLAR_VIEW
GLfloat distance = 6;
GLfloat twist = 0;
GLfloat elevation = 0;
GLfloat azimuth = 0;
#else
GLfloat g_eyex =  -0.60;		
GLfloat g_eyey = -0.90;
GLfloat g_eyez = -2.0;
#endif

#ifdef USE_GLU

// criar e destruir objectos quadric no  o mais eficiente
// aqui usa-se essa tecnica para criar novo objecto com o valor de slice e stacks intercativo

int cylinderWithTopAndBottom(GLenum mode)
{
	int list = glGenLists(2);
	GLUquadricObj* qobj = gluNewQuadric();
	gluQuadricDrawStyle(qobj, mode); //GLU_LINE //GLU_FILL
	gluQuadricNormals(qobj, GLU_SMOOTH);

	glNewList(list+1, GL_COMPILE);
		gluDisk(qobj, 0, 1.5, stacks, slices);
	glEndList();
	glNewList(list, GL_COMPILE);
		glCallList(list+1);
		gluCylinder(qobj, 1.5, 1.5, 2, slices, stacks);
		glTranslatef(0, 0, +2);
		glCallList(list+1);
	glEndList();
	
	gluDeleteQuadric(qobj);

	return list;
}

void cylinder(GLenum mode)
{
	GLUquadricObj* qobj = gluNewQuadric();
	gluQuadricDrawStyle(qobj, mode); //GLU_LINE //GLU_FILL
	gluQuadricNormals(qobj, GLU_SMOOTH);
	gluCylinder(qobj, 1.5, 1.5, 2, slices, stacks);
	gluDeleteQuadric(qobj);
}

void disk(GLenum mode)
{
	GLUquadricObj* qobj = gluNewQuadric();
	gluQuadricDrawStyle(qobj, mode); 
	gluQuadricNormals(qobj, GLU_SMOOTH);
	gluDisk(qobj, 0.5, 1.5, slices, stacks);
	gluDeleteQuadric(qobj);
}

void partialDisk(GLenum mode)
{
	GLUquadricObj* qobj = gluNewQuadric();
	gluQuadricDrawStyle(qobj, mode); 
	gluQuadricNormals(qobj, GLU_SMOOTH);
	gluPartialDisk(qobj, 0.5, 1.5, slices, stacks, 90, 270);
	gluDeleteQuadric(qobj);
}

void sphere(GLenum mode)
{
	GLUquadricObj* qobj = gluNewQuadric();
	gluQuadricDrawStyle(qobj, mode); 
	gluQuadricNormals(qobj, GLU_SMOOTH);
	gluSphere(qobj, 1.0, slices, stacks);
	gluDeleteQuadric(qobj);
}

#endif

#ifdef POLAR_VIEW
//void polarLookAt(GLfloat ro, GLfloat teta, GLfloat paralelo)
//{               
//	glTranslatef(0.0, 0.0, -ro);
//	glRotatef(teta, 1.0, 0.0, 0.0);
//	glRotatef(paralelo, 0.0, 1.0, 0.0);
//}

void polarView(GLdouble distance, GLdouble twist, GLdouble elevation, GLdouble azimuth)
{
	glTranslated(0.0, 0.0, -distance);
	glRotated(+elevation, 1.0, 0.0, 0.0);
	glRotated(azimuth, 0.0, 1.0, 0.0);
	glRotated(-twist, 0.0, 0.0, 1.0);
}
#endif

void drawAxis()
{
#define AXIS_LIMIT	4

	GLfloat mat_r[] = {1.0, 0.0, 0.0, 1.0};
	GLfloat mat_g[] = {0.0, 1.0, 0.0, 1.0};
	GLfloat mat_b[] = {0.0, 0.0, 1.0, 1.0};

	glPushAttrib(GL_LINE_BIT);
	//glLineWidth(2.0);
	glBegin(GL_LINES);
		// XX
		glColor4fv(mat_r);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_r);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(-AXIS_LIMIT, 0, 0);
		glVertex3f(+AXIS_LIMIT, 0, 0);

		// YY
		glColor4fv(mat_g);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_g);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(0, -AXIS_LIMIT, 0);
		glVertex3f(0, +AXIS_LIMIT, 0);

		// ZZ
		glColor4fv(mat_b);
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, mat_b);
		glNormal3f(0.0, 0.0, 1.0);
		glVertex3f(0, 0, -AXIS_LIMIT);
		glVertex3f(0, 0, +AXIS_LIMIT);
	glEnd();
	glPopAttrib();
}

void display()
{
#ifdef USE_GLU
	int l;
#endif
	GLfloat mat_obj[] = {0.6, 0.6, 0.6, 1.0};

	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

#ifdef POLAR_VIEW
	polarView(distance, twist, elevation, azimuth);
#else
	gluLookAt(g_eyex, g_eyey, g_eyez, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
#endif

	drawAxis();


	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mat_obj);

	switch (obj)
	{
#ifdef USE_GLU
	case MENU_GLU_CYLINDER2WIRE:
		l = cylinderWithTopAndBottom(GLU_LINE);
		glCallList(l);
		glDeleteLists(l, 2);
		break;
	case MENU_GLU_CYLINDER2SOLID:
		l = cylinderWithTopAndBottom(GLU_FILL);
		glCallList(l);
		glDeleteLists(l, 2);
		break;
	case MENU_GLU_WIRECYLINDER:
		cylinder(GLU_LINE);
		break;
	case MENU_GLU_SOLIDCYLINDER:
		cylinder(GLU_FILL);
		break;
	case MENU_GLU_WIREDISK:
		disk(GLU_LINE);
		break;
	case MENU_GLU_SOLIDDISK:
		disk(GLU_FILL);
		break;
	case MENU_GLU_WIREPARTIALDISK:
		partialDisk(GLU_LINE);
		break;
	case MENU_GLU_SOLIDPARTIALDISK:
		partialDisk(GLU_FILL);
		break;
	case MENU_GLU_WIRESPHERE:
		sphere(GLU_LINE);
		break;
	case MENU_GLU_SOLIDSPHERE:
		sphere(GLU_FILL);
		break;
#endif
	case MENU_GLUT_WIRESPHERE:
		glutWireSphere(1.5, slices, stacks);
		break;
	case MENU_GLUT_SOLIDSPHERE:
		glutSolidSphere(1.5, slices, stacks);
		break;
	case MENU_GLUT_WIRECONE:
		glutWireCone(1, 1.5, slices, stacks);
		break;
	case MENU_GLUT_SOLIDCONE:
		glutSolidCone(1, 1.5, slices, stacks);
		break;
	case MENU_GLUT_WIRECUBE:
		glutWireCube(1.5);
		break;
	case MENU_GLUT_SOLIDCUBE:
		glutSolidCube(1.5);
		break;
	case MENU_GLUT_WIRETORUS:
		glutWireTorus(0.5, 1.5, slices, stacks);
		break;
	case MENU_GLUT_SOLIDTORUS:
		glutSolidTorus(0.5, 1.5, slices, stacks);
		break;
	case MENU_GLUT_WIREDODECAHEDRON:
		glutWireDodecahedron();
		break;
	case MENU_GLUT_SOLIDDODECAHEDRON:
		glutSolidDodecahedron();
		break;
	case MENU_GLUT_WIREOCTAHEDRON:
		glutWireOctahedron();
		break;
	case MENU_GLUT_SOLIDOCTAHEDRON:
		glutSolidOctahedron();
		break;
	case MENU_GLUT_WIRETETRAHEDRON:
		glutWireTetrahedron();
		break;
	case MENU_GLUT_SOLIDTETRAHEDRON:
		glutSolidTetrahedron();
		break;
	case MENU_GLUT_WIREICOSAHEDRON:
		glutWireIcosahedron();
		break;
	case MENU_GLUT_SOLIDICOSAHEDRON:
		glutSolidIcosahedron();
		break;
	case MENU_GLUT_WIRETEAPOT:
		glutWireTeapot(1);
		break;
	case MENU_GLUT_SOLIDTEAPOT:
		glutSolidTeapot(1);
		break;
	}

	glFlush ();
}

void setview()
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//glOrtho(-3.0, 3.0, -3.0, 3.0, 0.1, 20.0);
	gluPerspective(60, 1, 1, 10);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
#ifdef POLAR_VIEW
	//polarLookAt(g_ro, g_teta, g_paralelo);
	polarView(distance, twist, elevation, azimuth);
#else
	gluLookAt(g_eyex, g_eyey, g_eyez, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
#endif
}

void reshape(int w, int h)
{
	glViewport(0, 0, w, h);
	setview();
}

#ifdef POLAR_VIEW
void reset_camera()
{
	distance = 6;
	twist = 0;
	elevation = 45;
	azimuth = -33;
}

void reset_camera_org()
{
	distance = 6;
	twist = 0;
	elevation = 0;
	azimuth = 0;
}
#else
void reset_camera()
{
	g_eyex = -0.6;
	g_eyey = -0.9;
	g_eyez = -2;
}

void reset_camera_org()
{
	g_eyex = 0;
	g_eyey = 0;
	g_eyez = -3;
}
#endif

void menu(int op)
{
	switch (op)
	{
	case MENU_EXIT:
		exit(0);
		break;
	case MENU_RESET_CAMERA:
		reset_camera();
		break;
	case MENU_RESET_CAMERAORG:
		reset_camera_org();
		break;
	default:
		obj = op;
		break;
	}
	glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y)
{
	switch (key)
	{
	case 27:
		exit(0);
		break;
	case 's':
		slices --;
		break;
	case 'S':
		slices ++;
		break;
	case 't':
		stacks--;
		break;
	case 'T':
		stacks++;
		break;
#ifdef POLAR_VIEW
	case 'x':
		azimuth -= 2;
		if (azimuth < 0)
			azimuth = 360;
		break;
	case 'X':
		azimuth += 2;
		if (azimuth > 360)
			azimuth = 0;
		break;
	case 'y':
		elevation -= 2;
		if (elevation < 0)
			elevation = 360;
		break;
	case 'Y':
		elevation += 2;
		if (elevation > 360)
			elevation = 0;
		break;
	case 'z':
		distance -= 0.2;
		break;
	case 'Z':
		distance += 0.2;
		break;
	case 'w':
		twist -= 2;
		if (twist < 0)
			twist = 360;
		break;
	case 'W':
		twist += 2;
		if (twist > 360)
			twist = 0;
		break;
#else
	case 'x':
		g_eyex-=0.1;
		break;
	case 'X':
		g_eyex+= 0.1;
		break;
	case 'y':
		g_eyey-=0.1;
		break;
	case 'Y':
		g_eyey+= 0.1;
		break;
	case 'z':
		g_eyez-=0.1;
		break;
	case 'Z':
		g_eyez+= 0.1;
		break;
#endif
	case 'r':
	case 'R':
		reset_camera();
		break;	
	case 'o':
	case 'O':
		reset_camera_org();
		break;	
	}
	glutPostRedisplay();
#ifdef _DEBUG 
#ifdef POLAR_VIEW
	printf("Camera: d: %f, e:%f, a:%f, t:%f\n", distance, elevation, azimuth, twist);
#else
	printf("Camera: %f, %f, %f\n", g_eyex, g_eyey, g_eyez);
#endif
#endif
}

void init()
{
  //GLfloat ambient[] =  {0.0, 0.0, 0.0, 1.0};
  //GLfloat diffuse[] =  {1.0, 1.0, 1.0, 1.0};
  //GLfloat position[] =  {0.0, 3.0, 3.0, 0.0};

  //GLfloat lmodel_ambient[] =  {0.2, 0.2, 0.2, 1.0};
  //GLfloat local_view[] =  {0.0};

  //glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
  //glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
  //glLightfv(GL_LIGHT0, GL_POSITION, position);
  //glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);
  //glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);

  glFrontFace(GL_CW);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  //glEnable(GL_AUTO_NORMAL);
  //glEnable(GL_NORMALIZE);
  glEnable(GL_DEPTH_TEST);
  //glDepthFunc(GL_LESS);

  //glShadeModel(GL_SMOOTH);

	setview();
	reset_camera();
}

void init_menus()
{
	int mnu = glutCreateMenu(menu);
#ifdef USE_GLU
	glutAddMenuEntry("GLU_CYLINDER (wire)",MENU_GLU_WIRECYLINDER);
	glutAddMenuEntry("GLU_CYLINDER (solid)",MENU_GLU_SOLIDCYLINDER);
	glutAddMenuEntry("GLU_DISK (wire)",MENU_GLU_WIREDISK);
	glutAddMenuEntry("GLU_DISK (solid)",MENU_GLU_SOLIDDISK);
	glutAddMenuEntry("GLU_PARTIALDISK (wire)",MENU_GLU_WIREPARTIALDISK);
	glutAddMenuEntry("GLU_PARTIALDISK (solid)",MENU_GLU_SOLIDPARTIALDISK);
	glutAddMenuEntry("GLU_SPHERE (wire)",MENU_GLU_WIRESPHERE);
	glutAddMenuEntry("GLU_SPHERE (solid)",MENU_GLU_SOLIDSPHERE);
	glutAddMenuEntry("wire cylinder with top && bottom",MENU_GLU_CYLINDER2WIRE);
	glutAddMenuEntry("solid cylinder with top && bottom",MENU_GLU_CYLINDER2SOLID);
#endif
	glutAddMenuEntry("GLUT_WIRESPHERE",MENU_GLUT_WIRESPHERE);
	glutAddMenuEntry("GLUT_SOLIDSPHERE",MENU_GLUT_SOLIDSPHERE);
	glutAddMenuEntry("GLUT_WIRECONE",MENU_GLUT_WIRECONE);
	glutAddMenuEntry("GLUT_SOLIDCONE",MENU_GLUT_SOLIDCONE);
	glutAddMenuEntry("GLUT_WIRECUBE",MENU_GLUT_WIRECUBE);
	glutAddMenuEntry("GLUT_SOLIDCUBE",MENU_GLUT_SOLIDCUBE);
	glutAddMenuEntry("GLUT_WIRETORUS",MENU_GLUT_WIRETORUS);
	glutAddMenuEntry("GLUT_SOLIDTORUS",MENU_GLUT_SOLIDTORUS);
	glutAddMenuEntry("GLUT_WIREDODECAHEDRON",MENU_GLUT_WIREDODECAHEDRON);
	glutAddMenuEntry("GLUT_SOLIDDODECAHEDRON",MENU_GLUT_SOLIDDODECAHEDRON);
	glutAddMenuEntry("GLUT_WIREOCTAHEDRON",MENU_GLUT_WIREOCTAHEDRON);
	glutAddMenuEntry("GLUT_SOLIDOCTAHEDRON",MENU_GLUT_SOLIDOCTAHEDRON);
	glutAddMenuEntry("GLUT_WIRETETRAHEDRON",MENU_GLUT_WIRETETRAHEDRON);
	glutAddMenuEntry("GLUT_SOLIDTETRAHEDRON",MENU_GLUT_SOLIDTETRAHEDRON);
	glutAddMenuEntry("GLUT_WIREICOSAHEDRON",MENU_GLUT_WIREICOSAHEDRON);
	glutAddMenuEntry("GLUT_SOLIDICOSAHEDRON",MENU_GLUT_SOLIDICOSAHEDRON);
	glutAddMenuEntry("GLUT_WIRETEAPOT",MENU_GLUT_WIRETEAPOT);
	glutAddMenuEntry("GLUT_SOLIDTEAPOT",MENU_GLUT_SOLIDTEAPOT);
	glutAddMenuEntry("Reset camera position",MENU_RESET_CAMERA);
	glutAddMenuEntry("Put camera at origin",MENU_RESET_CAMERAORG);
	glutAddMenuEntry("Exit",MENU_EXIT);

	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

int main(int argc, CHAR* argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize (250, 250);
	glutInitWindowPosition (100, 100);
	glutCreateWindow ("Solidos platonicos");
	init ();
	init_menus();
	glutKeyboardFunc(keyboard);
	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutMainLoop();

	return 0;
}

